import { World } from "@rbxts/matter"
import { clientState } from "ReplicatedStorage/ecs/state"
import WorldProvider from "./ui/contexts/worldContext"
import Roact from "@rbxts/roact"
import Main from "./ui/main"

const showGUI = (world: World, state: clientState): void => {
    const playerGui = state.player.WaitForChild("PlayerGui") as PlayerGui
    const tree = (
        <WorldProvider clientState={state} world={world}>
            <Main/>
        </WorldProvider>
    )
    Roact.mount(tree, playerGui, "gooplerGUI")
}

export default showGUI